%               Copyright (C) 2017 Joel Wraith

%This program is free software: you can redistribute it and/or modify it 
%under the terms of the GNU General Public License as published by the 
%Free Software Foundation, either version 3 of the License, or 
%(at your option) any later version.

%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.

%You should have received a copy of the GNU General Public License
%along with this program.  If not, see <http://www.gnu.org/licenses/>.

hologramVideo = VideoReader('stack.avi');
frames = int16(hologramVideo.Duration * hologramVideo.FrameRate);
imageValues = zeros([frames, 512, 512]);
ii=1;
while hasFrame(hologramVideo) 
   frame = rgb2gray(readFrame(hologramVideo));
   imageValues(ii,:,:) = frame;
   ii = ii + 1;
end

im = uint8(squeeze(min(imageValues)));

sensitivity = 0.93;
Rmin = 15;
Rmax = 50;
[centersBright, radiiBright] = imfindcircles(im,[Rmin Rmax], ...
'ObjectPolarity','bright', 'Sensitivity', sensitivity);
figure; imshow(im)
%viscircles(centersBright, radiiBright,'EdgeColor','b');
[centersDark, radiiDark] = imfindcircles(im, [Rmin Rmax], ...
'ObjectPolarity','dark', 'Sensitivity', sensitivity);
viscircles(centersBright, radiiBright,'EdgeColor','b');
viscircles(centersDark, radiiDark,'EdgeColor','g');